/* *##% 
 * ToPIA :: SOA
 * Copyright (C) 2004 - 2009 CodeLutin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 *
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * ##%*/

package org.nuiton.topia.service;

import java.lang.reflect.Method;

/**
 * TopiaServiceServer.java
 * 
 * Methodes communes a tous les servers renvoie l'appel sur le dispatcher
 * principal.
 * 
 * @author chatellier
 * @version $Revision: 1715 $
 * 
 * Last update : $Date: 2009-12-15 01:26:16 +0100 (mar. 15 déc. 2009) $ By : $Author: tchemit $
 */
public abstract class TopiaServiceServerAbstract implements TopiaServiceServer {

    /** Le dispatcher principal */
    private TopiaServiceProvider mainDispatcher;

    /**
     * Set dispatcher
     * 
     * @param mainDispatcher
     */
    public void setTopiaServiceProvider(TopiaServiceProvider mainDispatcher) {
        this.mainDispatcher = mainDispatcher;
    }

    /**
     * Disptach
     * 
     * @param method la methode
     * @param args les arguments
     * @return le resultat de l'appel
     */
    protected Object invoke(Method method, Object[] args) {
        return mainDispatcher.execute(method, args);
    }
}
